input fc[1:0], a[31:20], boot;
output dramsel, romsel, iosel, vmesel, vmea24, vmea16;

function okfc = (fc == <10>) | (fc == <01>);
function okboot = boot & (fc == <10>) & (a == $0:12);

dramsel = okfc & ~okboot & (a << $8:12);
romsel = okfc & (okboot | (($8:12 <= a) & (a << $c:12)));
iosel = okfc & (a == $e:12);
vmesel = okfc & (a >= $f:12);
vmea24 = a >= $ff0:12;
vmea16 = a == $00f:12;

define_pal adrdec = "gal20v8" {
	input a (13, 11:1);
	input fc (22, 14);
	input boot (23);
	output dramsel (15), romsel (16), iosel (17);
	output vmesel (18), vmea24 (19), vmea16 (20);
};
